unit ezmouse;

Interface
         uses crt, dos;



type
    EMouseType = (UNDEF,BUS,SERIAL,INPORT,PS2,HP);




const
     LEFT_BUTTON = 0;
     RIGHT_BUTTON = 1;



var
         iv,bt : word;
         MouseInstalled, NumberOfButtons : Integer; { ⨢஢.  ६  }
         MouseX,MouseY:Integer; {न }
         LeftPressed, RightPressed:Integer; {஢ઠ  }
         dummy:integer;
         ButtonX,ButtonY:integer;
         MouseMajor,MouseMinor:byte;
         MouseType : EMouseType;
         MouseIRQ  : byte;


         procedure InstallMouse; {⠭ ࠩ஢ }
         procedure ShowMouse; {뢮   ࠭}
         procedure HideMouse; { }
         procedure MouseXY; { ⥪騥 न }
         procedure ButtonPress; {  }
         procedure SetMouseXY(x,y:integer); {   x,y}
         procedure ButtonClick(button:integer); {।  뫠  ᫤ }
         procedure ConfineMouse(MinX,MinY,MaxX,MaxY:integer); {࠭稢  }
         procedure NormalConfine; {頥 ࠭祭   室}
         procedure MouseInfo; {gets ver, IRQ, type}
         Procedure ResetMouse;
         Procedure ChangeCursor(Offs,Segm:word;hhs,vhs:integer); {  }

Implementation

         procedure InstallMouse;
             begin
                {procedure installs mouse and returns succes, #buttons}
                asm
                   mov ax, 0h
                   int 33h
                   mov [iv], ax
                   mov [bt], bx
                end;
                if iv=65535 then MouseInstalled:=-1; { ⠭}
                if iv<>65535 then MouseInstalled:=0; { ⠭}
                NumberOfButtons:=bt;
           end;


         Procedure ShowMouse;
         begin
              asm
                 mov ax,01h
                 int 33h
              end;
         end;


         Procedure HideMouse;
         begin
              asm
                 mov ax,02h
                 int 33h
              end;
         end;


         Procedure MouseXY;
         begin
              asm
                 mov ax,03h
                 int 33h
                 mov [dummy],bx
                 mov [MouseX],cx
                 mov [MouseY],dx
              end;

         end;

         Procedure ButtonPress;
         begin
              asm
                 mov ax,03h
                 int 33h
                 mov [dummy],bx
              end;
              if dummy=1 then
                 begin
                      LeftPressed:=-1;
                      RightPressed:=0;
                 end;
              if dummy=2 then begin
                 LeftPressed:=0;
                 RightPressed:=-1;
                 end;
              if dummy=3 then begin
                 LeftPressed:=-1;
                 RightPressed:=-1;
                 end;
              if (((dummy<>1) and (dummy<>2)) and (dummy<>3)) then begin
                 LeftPressed:=0;
                 RightPressed:=0;
                 end;
         end;


         Procedure SetMouseXY(x,y:integer);
         begin
              asm
                 mov ax,04h
                 mov cx,[x]
                 mov dx,[y]
                 int 33h
              end;
         end;


        Procedure ButtonClick(button:integer);
        begin
             asm
                mov ax,05h
                mov bx,[button]
                int 33h
                mov [ButtonX],cx
                mov [ButtonY],dx
             end;
        end;


        procedure ConfineMouse(MinX,MinY,MaxX,MaxY:integer);
        begin
             asm
                mov ax,07h {ࢠ  }
                mov cx,[MinX]
                mov dx,[MaxX]
                int 33h
                mov ax,08h
                mov cx,[MinY]
                mov dx,[MaxY]
                int 33h
             end;
        end;

        procedure NormalConfine;
        begin
             asm
                mov ax,07h
                mov cx,0
                mov dx,639
                int 33h
                mov ax,08h
                mov cx,0
                mov dx,199
                int 33h
             end;
        end;


        procedure MouseInfo;
        begin
             asm
                mov ax,24h
                int 33h
                mov [MouseMajor],bh
                mov [MouseMinor],bl
                mov [MouseType],ch
                mov [MouseIRQ],cl
             end;
        end;


        Procedure ResetMouse;assembler;
        asm
           mov ax,21h
           int 33h
        end;

        Procedure ChangeCursor(Offs,Segm:word;hhs,vhs:integer);assembler;
        asm
               mov ax,09h
               mov bx,[hhs]
               mov cx,[vhs]
               mov es,[Segm]
               mov dx,[Offs]
               int 33h
        end;
end.




